package betterwithmods.common.entity.item;

import betterwithmods.module.hardcore.world.HCBuoy;
import net.minecraft.block.BlockLiquid;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.MoverType;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.init.Blocks;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.datasync.DataParameter;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.MathHelper;
import net.minecraft.world.World;

/**
 * @author Koward
 */
public class EntityItemBuoy extends EntityItem {
    private final static byte BUOYANCY_MAX_ITERATIONS = 10;
    private EntityItem watchItem = null;

    /**
     * Wrapper around EntityItem.
     */
    public EntityItemBuoy(EntityItem orig) {
        super(orig.func_130014_f_(), orig.field_70165_t, orig.field_70163_u, orig.field_70161_v, orig.func_92059_d().func_77946_l());
        NBTTagCompound originalData = new NBTTagCompound();
        orig.func_70014_b(originalData);
        this.func_70037_a(originalData);

        String thrower = orig.func_145800_j();
        Entity entity = thrower == null ? null : orig.func_130014_f_().func_72924_a(thrower);
        double tossSpeed = entity != null && entity.func_70051_ag() ? 2D : 1D;

        this.field_70159_w = orig.field_70159_w * tossSpeed;
        this.field_70181_x = orig.field_70181_x * tossSpeed;
        this.field_70179_y = orig.field_70179_y * tossSpeed;
    }

    /**
     * Required for entities. Not actually used anywhere.
     */
    @SuppressWarnings("unused")
    public EntityItemBuoy(World world) {
        super(world);
    }

    private void setAge(int age) {
        this.field_70292_b = age;
    }

    private int getAge0() {
        return this.field_70292_b;
    }

    private DataParameter<ItemStack> getITEM() {
        return field_184533_c;
    }

    private int getPickupDelay() {
        return this.field_145804_b;
    }

    /**
     * Called to update the entity's position/logic.
     */
    @Override
    public void func_70071_h_() {
        if (this.watchItem != null) {
            if (!this.watchItem.field_70128_L) {
                if (isEntityItemFake(this.watchItem)) {
                    this.func_70106_y();
                } else if (this.watchItem.field_70292_b > 2) {
                    watchItem.func_70106_y();
                    watchItem.func_174871_r();
                }
            }
        }
        ItemStack stack = this.func_184212_Q().func_187225_a(getITEM());
        if (!stack.func_190926_b() && stack.func_77973_b() != null && stack.func_77973_b().onEntityItemUpdate(this))
            return;
        if (this.func_92059_d().func_190926_b()) {
            this.func_70106_y();
        } else {
            // super.super.onUpdate() START
            if (!this.func_130014_f_().field_72995_K) {
                this.func_70052_a(6, this.func_184202_aL());
            }
            this.func_70030_z();
            // super.super.onUpdate() END

            if (getPickupDelay() > 0 && getPickupDelay() != 32767) {
                func_174867_a(getPickupDelay() - 1);
            }

            this.field_70169_q = this.field_70165_t;
            this.field_70167_r = this.field_70163_u;
            this.field_70166_s = this.field_70161_v;

            if (!this.func_189652_ae()) {
                this.field_70181_x -= 0.03999999910593033D;
            }
            updateBuoy();

            this.field_70145_X = this.func_145771_j(this.field_70165_t,
                    (this.func_174813_aQ().field_72338_b + this.func_174813_aQ().field_72337_e) / 2.0D, this.field_70161_v);
            this.func_70091_d(MoverType.SELF, this.field_70159_w, this.field_70181_x, this.field_70179_y);
            boolean flag = (int) this.field_70169_q != (int) this.field_70165_t || (int) this.field_70167_r != (int) this.field_70163_u
                    || (int) this.field_70166_s != (int) this.field_70161_v;

            if (flag || this.field_70173_aa % 25 == 0) {
                if (this.func_130014_f_().func_180495_p(new BlockPos(this)).func_185904_a() == Material.field_151587_i) {
                    this.field_70181_x = 0.20000000298023224D;
                    this.field_70159_w = (double) ((this.field_70146_Z.nextFloat() - this.field_70146_Z.nextFloat()) * 0.2F);
                    this.field_70179_y = (double) ((this.field_70146_Z.nextFloat() - this.field_70146_Z.nextFloat()) * 0.2F);
                    this.func_184185_a(SoundEvents.field_187658_bx, 0.4F, 2.0F + this.field_70146_Z.nextFloat() * 0.4F);
                }

                if (!this.func_130014_f_().field_72995_K) {
                    func_85054_d();
                }
            }

            float f = 0.98F;

            if (this.field_70122_E) {
                f = this.func_130014_f_().func_180495_p(new BlockPos(MathHelper.func_76128_c(this.field_70165_t),
                        MathHelper.func_76128_c(this.func_174813_aQ().field_72338_b) - 1,
                        MathHelper.func_76128_c(this.field_70161_v))).func_177230_c().field_149765_K * 0.98F;
            }

            this.field_70159_w *= (double) f;
            this.field_70181_x *= 0.9800000190734863D;
            this.field_70179_y *= (double) f;

            if (this.field_70122_E) {
                this.field_70181_x *= -0.5D;
            }

            if (this.getAge0() != -32768) {
                setAge(getAge0() + 1);
            }

            // this.handleWaterMovement();

            ItemStack item = this.func_184212_Q().func_187225_a(getITEM());

            if (!this.func_130014_f_().field_72995_K && this.getAge0() >= lifespan) {
                int hook = net.minecraftforge.event.ForgeEventFactory.onItemExpire(this, item);
                if (hook < 0)
                    this.func_70106_y();
                else
                    this.lifespan += hook;
            }
            if (item.func_190916_E() <= 0) {
                this.func_70106_y();
            }
        }
    }

    private void updateBuoy() {
        double waterAccumulator = 0.0D;
        final double offset = 0.1D;

        for (int i = 0; i < BUOYANCY_MAX_ITERATIONS; ++i) {
            double low = func_174813_aQ().field_72338_b
                    + (func_174813_aQ().field_72337_e - func_174813_aQ().field_72338_b) * (double) (i) * 0.375D + offset;
            double high = func_174813_aQ().field_72338_b
                    + (func_174813_aQ().field_72337_e - func_174813_aQ().field_72338_b) * (double) (i + 1) * 0.375D + offset;
            AxisAlignedBB boundingBox = new AxisAlignedBB(func_174813_aQ().field_72340_a, low, func_174813_aQ().field_72339_c,
                    func_174813_aQ().field_72336_d, high, func_174813_aQ().field_72334_f);

            if (!isAABBInMaterial(func_130014_f_(), boundingBox, Material.field_151586_h)) {
                break;
            }

            waterAccumulator += 1.0D / (double) BUOYANCY_MAX_ITERATIONS;
        }

        if (waterAccumulator > 0.001D) {
            if (!isDrifted()) {
                float buoyancy = HCBuoy.getBuoyancy(func_92059_d()) + 1.0F;
                field_70181_x += 0.04D * (double) buoyancy * waterAccumulator;
            }

            field_70159_w *= 0.9;
            field_70181_x *= 0.9;
            field_70179_y *= 0.9;
        }
    }

    /**
     * Check the non visible current between two water blocks for all blocks
     * nearby entity.
     */
    private boolean isDrifted() {
        int minX = MathHelper.func_76128_c(func_174813_aQ().field_72340_a);
        int maxX = MathHelper.func_76128_c(func_174813_aQ().field_72336_d + 1.0D);
        int minY = MathHelper.func_76128_c(func_174813_aQ().field_72338_b);
        int maxY = MathHelper.func_76128_c(func_174813_aQ().field_72337_e + 1.0D);
        int minZ = MathHelper.func_76128_c(func_174813_aQ().field_72339_c);
        int maxZ = MathHelper.func_76128_c(func_174813_aQ().field_72334_f + 1.0D);

        for (int x = minX; x < maxX; ++x) {
            for (int y = minY; y < maxY; ++y) {
                for (int z = minZ; z < maxZ; ++z) {
                    if (checkBlockDrifting(x, y, z))
                        return true;
                }
            }
        }

        return false;
    }

    /**
     * Check the non visible current between two water blocks.
     */
    private boolean checkBlockDrifting(int x, int y, int z) {
        for (int height = y - 1; height <= y + 1; height++) {
            IBlockState blockState = func_130014_f_().func_180495_p(new BlockPos(x, height, z));
            if (blockState.func_177230_c() == Blocks.field_150358_i || blockState.func_177230_c() == Blocks.field_150355_j) {
                int meta = blockState.func_177230_c().func_176201_c(blockState);
                if (meta >= 8)
                    return true;
            }
        }
        return false;
    }

    /**
     * Checks if the given AABB is in the material given.
     * Was in {@link World} before 1.11 and then was deleted. No idea where it went so this is a copy.
     */
    private boolean isAABBInMaterial(World world, AxisAlignedBB bb, Material materialIn) {
        int i = MathHelper.func_76128_c(bb.field_72340_a);
        int j = MathHelper.func_76143_f(bb.field_72336_d);
        int k = MathHelper.func_76128_c(bb.field_72338_b);
        int l = MathHelper.func_76143_f(bb.field_72337_e);
        int i1 = MathHelper.func_76128_c(bb.field_72339_c);
        int j1 = MathHelper.func_76143_f(bb.field_72334_f);
        BlockPos.PooledMutableBlockPos blockpos$pooledmutableblockpos = BlockPos.PooledMutableBlockPos.func_185346_s();

        for (int k1 = i; k1 < j; ++k1) {
            for (int l1 = k; l1 < l; ++l1) {
                for (int i2 = i1; i2 < j1; ++i2) {
                    IBlockState iblockstate = world.func_180495_p(blockpos$pooledmutableblockpos.func_181079_c(k1, l1, i2));

                    Boolean result = iblockstate.func_177230_c().isAABBInsideMaterial(world, blockpos$pooledmutableblockpos, bb, materialIn);
                    if (result != null) return result;

                    if (iblockstate.func_185904_a() == materialIn) {
                        int j2 = iblockstate.func_177229_b(BlockLiquid.field_176367_b);
                        double d0 = (double) (l1 + 1);

                        if (j2 < 8) {
                            d0 = (double) (l1 + 1) - (double) j2 / 8.0D;
                        }

                        if (d0 >= bb.field_72338_b) {
                            blockpos$pooledmutableblockpos.func_185344_t();
                            return true;
                        }
                    }
                }
            }
        }

        blockpos$pooledmutableblockpos.func_185344_t();
        return false;
    }

    public void setWatchItem(EntityItem item) {
        this.watchItem = item;
        appendAntiMergeTag(item.func_92059_d());
        this.watchItem.func_82142_c(true);
        if (this.watchItem.field_145804_b == 0)
            this.watchItem.func_174870_v();
    }

    private void appendAntiMergeTag(ItemStack stack) {
        NBTTagCompound tag = stack.func_77942_o() ? stack.func_77978_p() : new NBTTagCompound();
        if (tag == null) tag = new NBTTagCompound();
        tag.func_74757_a("NoPickup", true);
        stack.func_77982_d(tag);
    }

    private boolean isEntityItemFake(EntityItem item) {
        return item.field_145804_b == 32767 && item.field_70292_b == item.func_92059_d().func_77973_b().getEntityLifespan(item.func_92059_d(), item.func_130014_f_()) - 1;
    }
}
